<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Scoped CSS Variables and JS</title>
</head>

<body>
  <h2>Update CSS Variables with <span class='hl'>JS</span></h2>

  <div class="controls">
    <label for="spacing">Spacing:</label>
    <input id="spacing" type="range" name="spacing" min="10" max="200" value="10" data-sizing="px">

    <label for="blur">Blur:</label>
    <input id="blur" type="range" name="blur" min="0" max="25" value="10" data-sizing="px">

    <label for="base">Base Color</label>
    <input id="base" type="color" name="base" value="#ffc600">
  </div>

  <img src="https://source.unsplash.com/7bwQXzbF6KE/800x500">

  <style>
    /* aqui seteamos las variables de raiz, las cuales tienen como nombre cada input en la parte de arriba */
    :root {
      --base: #ffc600;
      --spacing: 10px;
      --blur: 10px;
    }

    /* aqui seteamos las variables en CSS que se van a modificar y se les da el valor que tendra en un futuro */
    img {
      padding: var(--spacing);
      background: var(--base);
      filter: blur(var(--blur));
    }

    /* Este tambien cambiara el color de JS en web, se puede eliminar para no cambiar, pero habra que setear un valor de color definido */
    .hl {
      color: var(--base);
    }

    /*
      misc styles, nothing to do with CSS variables
    */

    body {
      text-align: center;
      background: #193549;
      color: white;
      font-family: 'helvetica neue', sans-serif;
      font-weight: 100;
      font-size: 50px;
    }

    .controls {
      margin-bottom: 50px;
    }

    input {
      width: 100px;
    }
  </style>
  <script>
    // Cremaos una constante que hara una busqueda total de la clase .controls y sus inputs
    const inputs = document.querySelectorAll('.controls input');
    function handleUpdate() {
      //se declara suffix obteniendo el data set de cada que se este utulizando y si no hay nada, le da el valor vacio
      const suffix = this.dataset.sizing || '';
      //se Setea un document el cual seleccionara el elemtno y le dara un estilo, de la varibale que este tomando(--spacin, --blur o --base), tomara el valor y le agregara el data sete de sizing
      document.documentElement.style.setProperty(`--${this.name}`, this.value + suffix);
    }
    //Se setea un foreach para escuchar todos los eventos que se esten cambiando y mandar llamar la funcion handleUpdate para actualizarlo
    inputs.forEach(input => input.addEventListener('change', handleUpdate));
  </script>
</body>

</html>